/// <reference path="functions.jsx" />

function addCurvedAdjustmentLayer() {
    try {
        var desc1 = new ActionDescriptor();
        var ref1 = new ActionReference();
        ref1.putClass(Codes.adjustmentLayer);
        desc1.putReference(Codes.null, ref1);
        var desc2 = new ActionDescriptor();
        var desc3 = new ActionDescriptor();
        desc3.putEnumerated(Codes.presetKind, Codes.presetKindType, Codes.presetKindDefault);
        desc2.putObject(Codes.type, Codes.curves, desc3);
        desc1.putObject(Codes.using, Codes.adjustmentLayer, desc2);
        executeAction(Codes.make, desc1, DialogModes.NO);
    } catch (err) {
        alert("addCurvedAdjustmentLayer: " + err);
    }
}

// Set Curves Adjustment Layer
function setCurve(chan, coordinates, dialogMode) {
    try {
        switch (chan) {
            case 0:
            case null:
                curveChan = Codes.composite;
                break;
            case 1:
                curveChan = Codes.red;
                break;
            case 2:
                curveChan = Codes.green;
                break;
            case 3:
                curveChan = Codes.blue;
                break;
        }
        var desc1 = new ActionDescriptor();
        var ref1 = new ActionReference();
        ref1.putEnumerated(Codes.adjustmentLayer, Codes.ordinal, Codes.target);
        desc1.putReference(Codes.null, ref1);
        var desc2 = new ActionDescriptor();
        var list1 = new ActionList();
        var desc3 = new ActionDescriptor();
        var ref2 = new ActionReference();
        ref2.putEnumerated(Codes.channel, Codes.channel, curveChan);
        desc3.putReference(Codes.channel, ref2);
        //------------------------------------------------------
        // Put curve points
        var list2 = new ActionList();
        // Put 0/0
        var desc4 = new ActionDescriptor();
        desc4.putDouble(Codes.horizontal, 0);
        desc4.putDouble(Codes.vertical, 0);
        list2.putObject(Codes.point, desc4);
        // Put coordinates
        for (var ci = 0; ci < coordinates.length; ci++) {
            var pointDescriptor = new ActionDescriptor();
            pointDescriptor.putDouble(Codes.horizontal, coordinates[ci].x);
            pointDescriptor.putDouble(Codes.vertical, coordinates[ci].y);
            list2.putObject(Codes.point, pointDescriptor);
        }
        // Put 255/255
        var desc6 = new ActionDescriptor();
        desc6.putDouble(Codes.horizontal, 255);
        desc6.putDouble(Codes.vertical, 255);
        list2.putObject(Codes.point, desc6);
        desc3.putList(Codes.curve, list2);
        //-------------------------------------------------------
        list1.putObject(Codes.curvesAdjustment, desc3);
        desc2.putList(Codes.adjustment, list1);
        desc1.putObject(Codes.to, Codes.curves, desc2);
        executeAction(Codes.set, desc1, dialogMode || DialogModes.ERROR);
    } catch (err) {
        alert("setCurve: " + err);
    }
}