/**
 * Open a dialog to edit preset values for "UnSharp Mask". {amount,radius,threshold}
 */
function Dialog_UnSharpMask_Preset() {
    try {

        var result = {
            accepted: false,
            amount: _amount,
            radius: _radius,
            threshold: _threshold
        };

        var window = new Window("dialog", "Preset UnSharp Mask", undefined, {
            closeButton: true,
            su1PanelCoordinates: true
        });

        // Functions

        function addSection(parent, options, onChange) {

            // Build Layout

            var panel = parent.add("panel", undefined);
            panel.alignment = 'fill';

            var group = panel.add("group", undefined);
            group.alignment = 'fill';
            group.orientation = "row";
            group.add("statictext", undefined, options.label);

            var edit = group.add("edittext", undefined, options.value);
            edit.alignment = "fill";
            group.add("statictext", undefined, options.unit);

            var slider = panel.add("slider", undefined, options.value, options.min, options.max);
            slider.alignment = 'fill';

            // Add Listeners

            slider.addEventListener("change", function () {
                var value = parseFloat(slider.value);
                edit.text = value;
                onChange(value);
            });

            edit.addEventListener("change", function () {
                slider.value = parseFloat(edit.text);
                onChange(parseFloat(edit.text));
            });

        }

        var pnl = window.add("group", undefined);
        pnl.orientation = "column";

        addSection(pnl, { label: "Amount", min: 0, max: 200, value: result.amount, unit: "%" }, function (amount) {
            result.amount = amount;
        });
        addSection(pnl, { label: "Radius", min: 0, max: 100, value: result.radius, unit: "px" }, function (radius) {
            result.radius = radius;
        });
        addSection(pnl, { label: "Threshold", min: 0, max: 50, value: 0, unit: "Stellen" }, function (threshold) {
            result.threshold = threshold;
        });

        // Lower button group

        var groupFooter = window.add("group", undefined);
        groupFooter.orientation = "row";

        var acceptButton = groupFooter.add("button", undefined, "Set")
        acceptButton.onClick = function () {
            result.accepted = true;
            window.close();
        }

        var closeButton = groupFooter.add("button", undefined, "Close")
        closeButton.onClick = function () {
            window.close();
        }

        window.show();

        // Return result as JSON string back to extension
        return JSON.stringify(result);


    } catch (err) {
        alert("Error at Dialog/PresetUnSharpMask.jsx: " + err);
    }
}