/// <reference path="../functions.jsx" />
/// <reference path="../Curved Layer Functions.jsx" />

#include "../Curved Layer Functions.jsx"

function dodgeAndBurnGradient() {

    var undoAction = markHistoryPosition();
    var document = app.activeDocument;

    try {

        Beautypanel.checkBitsPerChannel();
        Beautypanel.checkBackgroundLayer();
        Beautypanel.refreshLayers();

        var dialogMode = BEAUTYPANEL.config.dialogMode;

        // ============================================ //
        // Ask user if existing layers may can be deleted.
        var deleteAndContinue = false;
        if (Beautypanel.layers.bright && Beautypanel.layers.dark) {
            deleteAndContinue = confirm(strings.request_undo_dodge_and_burn_gradient);
        }

        // ============================================ //
        if (!(Beautypanel.layers.dark && Beautypanel.layers.bright) || deleteAndContinue) {

            // ============================================ //
            // Delete bright and dark layer if they exist
            if (Beautypanel.layers.bright) Beautypanel.layers.bright.remove();
            if (Beautypanel.layers.dark) Beautypanel.layers.dark.remove();

            // ============================================ //
            // Create adjustment layer "Bright"
            addCurvedAdjustmentLayer()
            Beautypanel.layers.bright = document.activeLayer;
            Beautypanel.layers.bright.name = strings.layername_bright;
            setCurve(null, [
                { x: 84.0, y: 105.0 },
                { x: 188.0, y: 234.0 }
            ], dialogMode);
				Beautypanel.layers.bright.invert();
				Beautypanel.layers.bright.blendMode = BlendMode.LUMINOSITY;

            // ============================================ //
            // Create adjustment layer "Dark"
            addCurvedAdjustmentLayer();
            Beautypanel.layers.dark = document.activeLayer;
				Beautypanel.layers.dark.name = strings.layername_dark;
            setCurve(null, [
                { x: 63, y: 21 },
                { x: 166, y: 144 }
            ], dialogMode);
				Beautypanel.layers.dark.invert();
				Beautypanel.layers.dark.blendMode = BlendMode.LUMINOSITY;
				

        }

        // ============================================ //
        // Select brush to start painting
        app.currentTool = "paintbrushTool";

    } catch (err) {
        alert("Dodge and Burn - Gradient: " + err);
        undoAction();
    }

}

dodgeAndBurnGradient();
