/// <reference path="../functions.jsx" />

#include "../Curved Layer Functions.jsx"

function dodgeAndBurnGray() {

    var undoAction = markHistoryPosition();

    try {

        Beautypanel.checkBitsPerChannel();
        Beautypanel.refreshLayers();

        // ======================================================= //
        var document = app.activeDocument;
        var dialogMode = DialogModes.ERROR;

        // ======================================================= //
        // Ask user for permission to delete existing Layer
        var deleteAndContinue = false;
        if ($.layers.dodgeAndBurnGray) {
            deleteAndContinue = confirm(strings.request_undo_dodge_and_burn_gray)
        }

        // ======================================================= //
        if (!$.layers.dodgeAndBurnGray || deleteAndContinue) {

            // ======================================================= //
            // Delete DnB Gray layer if it exists
            if ($.layers.dodgeAndBurnGray) {
                $.layers.dodgeAndBurnGray.remove();
            }

            // ======================================================= //
            // Create new layer with blendmode SoftLight
            $.layers.dodgeAndBurnGray = document.artLayers.add();
            $.layers.dodgeAndBurnGray.name = strings.layername_dodgeAndBurnGray;
            $.layers.dodgeAndBurnGray.blendMode = BlendMode.SOFTLIGHT;

            // ======================================================= //
            // Fill layer with gray color
            var descriptor = new ActionDescriptor();
            descriptor.putEnumerated(Codes.using, Codes.fillContents, Codes.gray);
            descriptor.putUnitDouble(Codes.opacity, Codes.percentUnit, 100.000000);
            descriptor.putEnumerated(Codes.mode, Codes.blendMode, Codes.normal);
            executeAction(Codes.fill, descriptor, DialogModes.NO);

        }

        // ======================================================= //
        app.currentTool = "paintbrushTool";

    } catch (err) {
        alert(err);
        undoAction();
    }

}

dodgeAndBurnGray();