/// <reference path="../functions.jsx" />

#include "../extends/LayerUtils.jsx"
#include "../extends/DocumentUtils.jsx"

function enhanceDetails() {

        var undoAction = markHistoryPosition();

    try {

        Beautypanel.checkBitsPerChannel();
        Beautypanel.checkBackgroundLayer();
        Beautypanel.refreshLayers();

        // ======================================================= //
        var document = app.activeDocument;
        var referenceLayer = document.backgroundLayer;

        // ======================================================= //
        // Ask user for permission to delete existing layer
        if (layers.enhanceDetails) {
            var deleteAndContinue = confirm(strings.request_undo_enhance_details);
            if (!deleteAndContinue) {
                return;
            }
        }

        // ======================================================= //
        // If layer exists, delete it.
        if (layers.enhanceDetails) {
            layers.enhanceDetails.remove();
        }

        // ======================================================= //
        // Create reference layer
        var tempLayer = referenceLayer.duplicate();
        tempLayer.opacity = 1;
        document.backgroundLayer.duplicate()
        tempLayer = tempLayer.merge();

        // ======================================================= //
        // Invert reference layer
        var inverted = tempLayer.duplicate();
        inverted.invert();
        inverted.blendMode = BlendMode.VIVIDLIGHT;
        $.LayerUtils.applySurfaceBlur(inverted, 34, 36, DialogModes.ALL);

        // ======================================================= //
        // Merge layers and finalize action
        layers.enhanceDetails = inverted.merge();
        layers.enhanceDetails.name = strings.layername_enhancedDetails;
        layers.enhanceDetails.blendMode = BlendMode.OVERLAY;
        layers.enhanceDetails.opacity = 50;

        layers.enhanceDetails.move(document.artLayers[0], ElementPlacement.PLACEBEFORE);
        $.LayerUtils.createRvlaMask(layers.enhanceDetails);

    } catch (err) {
        alert('Enhance Details: ' + err);
        undoAction();
        return false;
    }

    return true;
}

enhanceDetails();

