
function CollectDocumentInfo() {

  var documentInfo = {
    file: null,
    folder: null,
    name: "",
    format: "NONE",
    width: null,
    height: null,
    pixelAspectRatio: null
  };

  if (app.activeDocument) {

    var doc = app.activeDocument;

    documentInfo.width = doc.width.as("px");
    documentInfo.height = doc.height.as("px");
    
    getFileInformation(documentInfo, doc)

  }

  return JSON.stringify(documentInfo);
}

function getFileInformation(documentInfo, document) {

  try {

    documentInfo.file = document.fullName.fsName;
    documentInfo.name = document.name;
    documentInfo.folder = document.path.fsName;

    if (documentInfo.name.length > 0) {
      documentInfo.format = /(?:\.([^.]+))?$/.exec(documentInfo.name)[1];
    }

  } catch (err) {
  }

}

CollectDocumentInfo();
