
if (typeof console !== "object") {
    console = {};
}

try {

    var VAR_TIMESTAMP = "$TIMESTAMP";
    var VAR_LEVEL = "$LEVEL";
    var VAR_MESSAGE = "$MESSAGE";

    var _logPattern = "$timestamp [$level] - $message";

    if (!console.log) {

        console.log = function (message) {

            var level = "log";

            var s = resolveString(_logPattern, {
                "$timestamp": getTimeStamp(),
                "$level": level.toUpperCase(),
                "$message": message
            });

            $.writeln(message);

        }

    }

    if (!console.warn) {

        console.warn = function (message) {

            var level = "warn";

            var s = resolveString(_logPattern, {
                "$timestamp": getTimeStamp(),
                "$level": level.toUpperCase(),
                "$message": message
            });

            $.writeln(message);

        }

    }

    if (!console.error) {

        console.error = function (message) {

            var level = "error";

            var s = resolveString(_logPattern, {
                "$timestamp": getTimeStamp(),
                "$level": level.toUpperCase(),
                "$message": message
            });

            $.writeln(message);

        }

    }

} catch (err) {

}

function openLogFile(level) {

}

function getTimeStamp(pattern) {

    var pattern = pattern || "$year.$month.$day $hours:$minutes:$seconds";

    // Get the time and format it  
    var digital = new Date();
    var hours = digital.getHours();
    var minutes = digital.getMinutes();
    var seconds = digital.getSeconds();
    var amOrPm = "AM";
    if (hours > 11) amOrPm = "PM";
    if (hours > 12) hours = hours - 12;
    if (hours == 0) hours = 12;
    if (minutes <= 9) minutes = "0" + minutes;
    if (seconds <= 9) seconds = "0" + seconds;

    // Get the date and format it  
    var date = new Date();
    var d = date.getDate();
    var day = (d < 10) ? '0' + d : d;
    var m = date.getMonth() + 1;
    var month = (m < 10) ? '0' + m : m;
    var yy = date.getYear();
    var year = (yy < 1000) ? yy + 1900 : yy;

    // create a variable with the fully formatted the time and date  
    var MonthNames = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
    //todaysDate = hours + ":" + minutes + ":" + seconds + " " + amOrPm + " " + MonthNames[date.getMonth()] + " " + date.getDate() + ", " + year;

    var stamp = resolveString(pattern, {
        "$year": year,
        "$month": date.getMonth(),
        "$day": date.getDate(),
        "$hours": hours,
        "$minutes": minutes,
        "$seconds": seconds
    });

    return todaysDate;
}

function resolveString(pattern, dictionary) {

    var resolvedString = pattern;

    for (var key in dictionary) {

        var varName = key;
        var value = dictionary[value];

        resolvedString = resolvedString.split(varName).join(value);

    }

    return resolvedString;

}