/// <reference path="../functions.jsx" />

function frequencySeparationSharp() {
    
    var undoAction = markHistoryPosition();

    try {

        Beautypanel.refreshLayers();

        var document = app.activeDocument;

        if (!$.layers.detail) {
            #include "../Frequency Separation.jsx"
        }

        $.layers.detailBlackWhite = $.layers.detail.duplicate();
        $.layers.detailBlackWhite.name = strings.layername_detail_bw;
        $.layers.detailColor = layers.detail;
        $.layers.detailColor.name = strings.layername_detail_color;

        $.layers.detailBlackWhite.blendMode = $.layers.detailColor.blendMode = BlendMode.LINEARLIGHT;
        $.LayerUtils.applySaturation($.layers.detailBlackWhite);
        $.LayerUtils.applyCalculation($.layers.detailColor, $.layers.detailBlackWhite, "RGB ", true, "Add ", 2, 0)

        document.activeLayer = $.layers.detailBlackWhite;
        Beautypanel.unsharpMask(undefined, undefined, undefined, false, true);

        // Merge DetailBW, DetailColor, Soft
        var mergedLayer = $.DocumentUtils.mergeLayers(document, [
            $.layers.detailBlackWhite,
            $.layers.detailColor, 
            $.layers.soft
        ]);
        $.layers.referenceLayer = mergedLayer;

        // Rerun FreqSep to create Detail and Soft layer
        #include "../Frequency Separation.jsx"

        if (mergedLayer)
            mergedLayer.remove();

    } catch (err) {
        alert("Error at 'Frequency Separation Sharpen': " + err);
        undoAction();
    }
}

frequencySeparationSharp();