/// <reference path="../functions.jsx" />
/// <reference path="../Curved Layer Functions.jsx" />

(function () {

    var undoAction = markHistoryPosition();

    try {

        var doc = app.activeDocument;

        Beautypanel.refreshLayers();

        // ===================================================================== //
        // Change document mode to LAB
        var previousMode = toChangeMode(doc.mode);
        doc.changeMode(ChangeMode.LAB);

        // ===================================================================== //
        // Helligkeitskanal als einzigen sichtbar schalten
        // Problem? Man kann ihn anscheinend nur über den Namen identifizieren.
        // Nächstes Problem: Sprache, Umbenennung durch Nutzer, etc

        var brightnessChannelNames = [
            "Luminosity",
            "Brightness",
            "Helligkeit"
        ].join(";");

        var channels = doc.channels;
        for (var i = 0; i < channels.length; i++) {
            var channel = channels[i];
            //channel.visible = brightnessChannelNames.indexOf(channel.name) > -1;
            channel.visible = !(channel.name == "a" || channel.name == "b");
        }

        // ===================================================================== //
        #include "./UnsharpMask.jsx"

    } catch (err) {
        alert(err);
        undoAction();
    } finally {
        // ===================================================================== //
        // Change document back to previous mode.
        doc.changeMode(previousMode);
    }

})();