/// <reference path="../functions.jsx" />

#include "../SuS.Photoshop.jsx"
#include "../ConfigFile.jsx"

var wtf = null;

function selectiveSharp(sharpSet, depthSet, lightSet) {
  // =======================================================
  var idsmartSharpen = stringIDToTypeID("smartSharpen");
  var actionDescriptor = new ActionDescriptor();
  var idpresetKind = stringIDToTypeID("presetKind");
  var idpresetKindType = stringIDToTypeID("presetKindType");
  var idpresetKindCustom = stringIDToTypeID("presetKindCustom");
  actionDescriptor.putEnumerated(idpresetKind, idpresetKindType, idpresetKindCustom);
  var iduseLegacy = stringIDToTypeID("useLegacy");
  actionDescriptor.putBoolean(iduseLegacy, false);
  // ========================================================================== //
  // Set Amount
  var idAmnt = charIDToTypeID("Amnt");
  var idPrc = charIDToTypeID("#Prc");
  actionDescriptor.putUnitDouble(idAmnt, idPrc, sharpSet.amount);
  // Set Radius
  var idRds = charIDToTypeID("Rds ");
  var idPxl = charIDToTypeID("#Pxl");
  actionDescriptor.putUnitDouble(idRds, idPxl, sharpSet.radius);
  // Noise reduction
  var idnoiseReduction = stringIDToTypeID("noiseReduction");
  var idPrc = charIDToTypeID("#Prc");
  actionDescriptor.putUnitDouble(idnoiseReduction, idPrc, sharpSet.noiseReduction);
  // ========================================================================== //
  var idblur = charIDToTypeID("blur");
  var idblurType = stringIDToTypeID("blurType");
  var idlensBlur = stringIDToTypeID("lensBlur");
  actionDescriptor.putEnumerated(idblur, idblurType, idlensBlur);
  // ========================================================================== //
  // Depth Parameters
  var idsdwM = charIDToTypeID("sdwM");
  var depthDescriptor = new ActionDescriptor();
  // Amount
  var idAmnt = charIDToTypeID("Amnt");
  var idPrc = charIDToTypeID("#Prc");
  depthDescriptor.putUnitDouble(idAmnt, idPrc, depthSet.fade);
  // Width
  var idWdth = charIDToTypeID("Wdth");
  var idPrc = charIDToTypeID("#Prc");
  depthDescriptor.putUnitDouble(idWdth, idPrc, depthSet.width);
  // Radius
  var idRds = charIDToTypeID("Rds ");
  depthDescriptor.putInteger(idRds, depthSet.radius);
  // Put object into action descriptor
  var idadaptCorrectTones = stringIDToTypeID("adaptCorrectTones");
  actionDescriptor.putObject(idsdwM, idadaptCorrectTones, depthDescriptor);
  // ========================================================================== //
  // Light Parameters
  var idhglM = charIDToTypeID("hglM");
  var lightDescriptor = new ActionDescriptor();
  // Amount
  var idAmnt = charIDToTypeID("Amnt");
  var idPrc = charIDToTypeID("#Prc");
  lightDescriptor.putUnitDouble(idAmnt, idPrc, lightSet.fade);
  // Width
  var idWdth = charIDToTypeID("Wdth");
  var idPrc = charIDToTypeID("#Prc");
  lightDescriptor.putUnitDouble(idWdth, idPrc, lightSet.width);
  // Radius
  var idRds = charIDToTypeID("Rds ");
  lightDescriptor.putInteger(idRds, lightSet.radius);
  // Put object into action descriptor
  var idadaptCorrectTones = stringIDToTypeID("adaptCorrectTones");
  actionDescriptor.putObject(idhglM, idadaptCorrectTones, lightDescriptor);
  // ========================================================================== //
  // Execute Selective Sharpen Action
  var finalDescriptor = executeAction(idsmartSharpen, actionDescriptor, DialogModes.ALL);
  // ========================================================================== //
  // Read submitted parameters from dialog
  var blockDepthDescriptor = finalDescriptor.getObjectValue(idsdwM);
  var blockLightDescriptor = finalDescriptor.getObjectValue(idhglM);
  var finalParameters = {
    amount: finalDescriptor.getDouble(idAmnt),
    radius: finalDescriptor.getDouble(idRds),
    noiseReduction: finalDescriptor.getDouble(idnoiseReduction),
    depthSet: {
      amount: blockDepthDescriptor.getDouble(idAmnt),
      width: blockDepthDescriptor.getDouble(idWdth),
      radius: blockDepthDescriptor.getDouble(idRds)
    },
    lightSet: {
      amount: blockLightDescriptor.getDouble(idAmnt),
      width: blockLightDescriptor.getDouble(idWdth),
      radius: blockLightDescriptor.getDouble(idRds)
    }
  };
}

function SelectiveSharpen() {

  var undoAction = markHistoryPosition();

  try {

    Beautypanel.refreshLayers();

    var c = BEAUTYPANEL.config.unsharpMask;

    wtf = new ConfigFile(c.configurationFile);

    var sharpSet = {
      amount: c.amount,
      radius: c.radius,
      noiseReduction: 20
    };

    var depthSet = {
      fade: 20,
      width: 50,
      radius: 20
    };

    var lightSet = {
      fade: 20,
      width: 50,
      radius: 20
    };

    selectiveSharp(sharpSet, depthSet, lightSet);

  } catch (err) {
    alert("Error at SelectiveSharpen.jsx: " + err)
    undoAction();
  }

}

SelectiveSharpen();
