/// <reference path="ArtLayer.jsx" />

try {

    if (!("mergeLayers" in Document.prototype)) {

        Document.prototype.mergeLayers = function mergeLayers() {

            if (arguments.length <= 0) {
                alert("No layers to merge given");
                return;
            }

            var self = this;

            var args = arguments;
            var name = args[0].name;

            usingDocument(this, function () {

                // Deselect all
                self.activeLayer = args[0];

                // Select layers to merge
                for (var i = 0; i < args.length; i++) {

                    var layer = args[i];

                    var desc = new ActionDescriptor();
                    var ref = new ActionReference();
                    ref.putName(charIDToTypeID("Lyr "), layer.name);
                    desc.putReference(charIDToTypeID("null"), ref);
                    desc.putEnumerated(stringIDToTypeID("selectionModifier"), stringIDToTypeID("selectionModifierType"), stringIDToTypeID("addToSelection"));
                    desc.putBoolean(charIDToTypeID("MkVs"), false);

                    app.executeAction(charIDToTypeID("slct"), desc, DialogModes.NO);

                }

                // Do the merge
                app.executeAction(cTID("Mrg2"), new ActionDescriptor(), DialogModes.NO);

            });

            return this.artLayers.getByName(name);
        }

    }

    if (!("getLayerByName" in Document.prototype)) {
        Document.prototype.getLayerByName = function (name) {
            try {
                return this.layers.getByName(name);
            } catch (err) {
                // Dummy error. Photoshop throws an error if layer does not exist. We simply return null.
                return null;
            }
        }
    }

} catch (err) {
    alert("Error at prototype/Document.jsx: " + err);
}